/* FontConfig.c generated by valac 0.44.7, the Vala compiler
 * generated from FontConfig.vala, do not modify */

/* FontConfig.vala
 *
 * Copyright (C) 2009 - 2019 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "string-hashset.h"
#include "font-manager-source.h"
#include "font-manager-fontconfig.h"
#include "utils.h"
#include "font-manager-properties.h"
#include "font-manager-font.h"
#include "font-manager-xml-writer.h"
#include "font-manager-json-proxy.h"
#include "font-manager-selections.h"
#include <libxml/tree.h>
#include <libxml/parser.h>
#include "font-manager-database.h"
#include <sqlite3.h>
#include <gio/gio.h>

typedef enum  {
	FONT_MANAGER_WIDTH_ULTRACONDENSED = 50,
	FONT_MANAGER_WIDTH_EXTRACONDENSED = 63,
	FONT_MANAGER_WIDTH_CONDENSED = 75,
	FONT_MANAGER_WIDTH_SEMICONDENSED = 87,
	FONT_MANAGER_WIDTH_NORMAL = 100,
	FONT_MANAGER_WIDTH_SEMIEXPANDED = 113,
	FONT_MANAGER_WIDTH_EXPANDED = 125,
	FONT_MANAGER_WIDTH_EXTRAEXPANDED = 150,
	FONT_MANAGER_WIDTH_ULTRAEXPANDED = 200
} FontManagerWidth;

#define FONT_MANAGER_TYPE_WIDTH (font_manager_width_get_type ())
typedef enum  {
	FONT_MANAGER_SLANT_ROMAN = 0,
	FONT_MANAGER_SLANT_ITALIC = 100,
	FONT_MANAGER_SLANT_OBLIQUE = 110
} FontManagerSlant;

#define FONT_MANAGER_TYPE_SLANT (font_manager_slant_get_type ())
typedef enum  {
	FONT_MANAGER_WEIGHT_THIN = 0,
	FONT_MANAGER_WEIGHT_EXTRALIGHT = 40,
	FONT_MANAGER_WEIGHT_ULTRALIGHT = 40,
	FONT_MANAGER_WEIGHT_LIGHT = 50,
	FONT_MANAGER_WEIGHT_BOOK = 75,
	FONT_MANAGER_WEIGHT_REGULAR = 80,
	FONT_MANAGER_WEIGHT_NORMAL = 80,
	FONT_MANAGER_WEIGHT_MEDIUM = 100,
	FONT_MANAGER_WEIGHT_DEMIBOLD = 180,
	FONT_MANAGER_WEIGHT_SEMIBOLD = 180,
	FONT_MANAGER_WEIGHT_BOLD = 200,
	FONT_MANAGER_WEIGHT_EXTRABOLD = 205,
	FONT_MANAGER_WEIGHT_BLACK = 210,
	FONT_MANAGER_WEIGHT_HEAVY = 210,
	FONT_MANAGER_WEIGHT_EXTRABLACK = 215,
	FONT_MANAGER_WEIGHT_ULTRABLACK = 215
} FontManagerWeight;

#define FONT_MANAGER_TYPE_WEIGHT (font_manager_weight_get_type ())
typedef enum  {
	FONT_MANAGER_SPACING_PROPORTIONAL = 0,
	FONT_MANAGER_SPACING_DUAL = 90,
	FONT_MANAGER_SPACING_MONO = 100,
	FONT_MANAGER_SPACING_CHARCELL = 110
} FontManagerSpacing;

#define FONT_MANAGER_TYPE_SPACING (font_manager_spacing_get_type ())
typedef enum  {
	FONT_MANAGER_HINT_STYLE_NONE,
	FONT_MANAGER_HINT_STYLE_SLIGHT,
	FONT_MANAGER_HINT_STYLE_MEDIUM,
	FONT_MANAGER_HINT_STYLE_FULL
} FontManagerHintStyle;

#define FONT_MANAGER_TYPE_HINT_STYLE (font_manager_hint_style_get_type ())
typedef enum  {
	FONT_MANAGER_LCD_FILTER_NONE,
	FONT_MANAGER_LCD_FILTER_DEFAULT,
	FONT_MANAGER_LCD_FILTER_LIGHT,
	FONT_MANAGER_LCD_FILTER_LEGACY
} FontManagerLCDFilter;

#define FONT_MANAGER_TYPE_LCD_FILTER (font_manager_lcd_filter_get_type ())
typedef enum  {
	FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN,
	FONT_MANAGER_SUBPIXEL_ORDER_RGB,
	FONT_MANAGER_SUBPIXEL_ORDER_BGR,
	FONT_MANAGER_SUBPIXEL_ORDER_VRGB,
	FONT_MANAGER_SUBPIXEL_ORDER_VBGR,
	FONT_MANAGER_SUBPIXEL_ORDER_NONE
} FontManagerSubpixelOrder;

#define FONT_MANAGER_TYPE_SUBPIXEL_ORDER (font_manager_subpixel_order_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_MANAGER_TYPE_DEFAULT_PROPERTIES (font_manager_default_properties_get_type ())
#define FONT_MANAGER_DEFAULT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties))
#define FONT_MANAGER_DEFAULT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultPropertiesClass))
#define FONT_MANAGER_IS_DEFAULT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES))
#define FONT_MANAGER_IS_DEFAULT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES))
#define FONT_MANAGER_DEFAULT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultPropertiesClass))

typedef struct _FontManagerDefaultProperties FontManagerDefaultProperties;
typedef struct _FontManagerDefaultPropertiesClass FontManagerDefaultPropertiesClass;
typedef struct _FontManagerDefaultPropertiesPrivate FontManagerDefaultPropertiesPrivate;
enum  {
	FONT_MANAGER_DEFAULT_PROPERTIES_0_PROPERTY,
	FONT_MANAGER_DEFAULT_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_default_properties_properties[FONT_MANAGER_DEFAULT_PROPERTIES_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_DISPLAY_PROPERTIES (font_manager_display_properties_get_type ())
#define FONT_MANAGER_DISPLAY_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES, FontManagerDisplayProperties))
#define FONT_MANAGER_DISPLAY_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES, FontManagerDisplayPropertiesClass))
#define FONT_MANAGER_IS_DISPLAY_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES))
#define FONT_MANAGER_IS_DISPLAY_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES))
#define FONT_MANAGER_DISPLAY_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES, FontManagerDisplayPropertiesClass))

typedef struct _FontManagerDisplayProperties FontManagerDisplayProperties;
typedef struct _FontManagerDisplayPropertiesClass FontManagerDisplayPropertiesClass;
typedef struct _FontManagerDisplayPropertiesPrivate FontManagerDisplayPropertiesPrivate;
enum  {
	FONT_MANAGER_DISPLAY_PROPERTIES_0_PROPERTY,
	FONT_MANAGER_DISPLAY_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_display_properties_properties[FONT_MANAGER_DISPLAY_PROPERTIES_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_FONT_PROPERTIES (font_manager_font_properties_get_type ())
#define FONT_MANAGER_FONT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties))
#define FONT_MANAGER_FONT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontPropertiesClass))
#define FONT_MANAGER_IS_FONT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FONT_PROPERTIES))
#define FONT_MANAGER_IS_FONT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FONT_PROPERTIES))
#define FONT_MANAGER_FONT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontPropertiesClass))

typedef struct _FontManagerFontProperties FontManagerFontProperties;
typedef struct _FontManagerFontPropertiesClass FontManagerFontPropertiesClass;
typedef struct _FontManagerFontPropertiesPrivate FontManagerFontPropertiesPrivate;
enum  {
	FONT_MANAGER_FONT_PROPERTIES_0_PROPERTY,
	FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY,
	FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY,
	FONT_MANAGER_FONT_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_NUM_PROPERTIES];
enum  {
	FONT_MANAGER_FONT_PROPERTIES_CHANGED_SIGNAL,
	FONT_MANAGER_FONT_PROPERTIES_NUM_SIGNALS
};
static guint font_manager_font_properties_signals[FONT_MANAGER_FONT_PROPERTIES_NUM_SIGNALS] = {0};

#define FONT_MANAGER_TYPE_ACCEPT (font_manager_accept_get_type ())
#define FONT_MANAGER_ACCEPT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_ACCEPT, FontManagerAccept))
#define FONT_MANAGER_ACCEPT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_ACCEPT, FontManagerAcceptClass))
#define FONT_MANAGER_IS_ACCEPT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_ACCEPT))
#define FONT_MANAGER_IS_ACCEPT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_ACCEPT))
#define FONT_MANAGER_ACCEPT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_ACCEPT, FontManagerAcceptClass))

typedef struct _FontManagerAccept FontManagerAccept;
typedef struct _FontManagerAcceptClass FontManagerAcceptClass;
typedef struct _FontManagerAcceptPrivate FontManagerAcceptPrivate;
enum  {
	FONT_MANAGER_ACCEPT_0_PROPERTY,
	FONT_MANAGER_ACCEPT_NUM_PROPERTIES
};
static GParamSpec* font_manager_accept_properties[FONT_MANAGER_ACCEPT_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_DIRECTORIES (font_manager_directories_get_type ())
#define FONT_MANAGER_DIRECTORIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories))
#define FONT_MANAGER_DIRECTORIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectoriesClass))
#define FONT_MANAGER_IS_DIRECTORIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DIRECTORIES))
#define FONT_MANAGER_IS_DIRECTORIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DIRECTORIES))
#define FONT_MANAGER_DIRECTORIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectoriesClass))

typedef struct _FontManagerDirectories FontManagerDirectories;
typedef struct _FontManagerDirectoriesClass FontManagerDirectoriesClass;
typedef struct _FontManagerDirectoriesPrivate FontManagerDirectoriesPrivate;
enum  {
	FONT_MANAGER_DIRECTORIES_0_PROPERTY,
	FONT_MANAGER_DIRECTORIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_directories_properties[FONT_MANAGER_DIRECTORIES_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_REJECT (font_manager_reject_get_type ())
#define FONT_MANAGER_REJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_REJECT, FontManagerReject))
#define FONT_MANAGER_REJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_REJECT, FontManagerRejectClass))
#define FONT_MANAGER_IS_REJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_REJECT))
#define FONT_MANAGER_IS_REJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_REJECT))
#define FONT_MANAGER_REJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_REJECT, FontManagerRejectClass))

typedef struct _FontManagerReject FontManagerReject;
typedef struct _FontManagerRejectClass FontManagerRejectClass;
typedef struct _FontManagerRejectPrivate FontManagerRejectPrivate;
enum  {
	FONT_MANAGER_REJECT_0_PROPERTY,
	FONT_MANAGER_REJECT_NUM_PROPERTIES
};
static GParamSpec* font_manager_reject_properties[FONT_MANAGER_REJECT_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define FONT_MANAGER_TYPE_SOURCES (font_manager_sources_get_type ())
#define FONT_MANAGER_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_SOURCES, FontManagerSources))
#define FONT_MANAGER_SOURCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_SOURCES, FontManagerSourcesClass))
#define FONT_MANAGER_IS_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_SOURCES))
#define FONT_MANAGER_IS_SOURCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_SOURCES))
#define FONT_MANAGER_SOURCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_SOURCES, FontManagerSourcesClass))

typedef struct _FontManagerSources FontManagerSources;
typedef struct _FontManagerSourcesClass FontManagerSourcesClass;
typedef struct _FontManagerSourcesPrivate FontManagerSourcesPrivate;

#define FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS (font_manager_sources_file_monitors_get_type ())
#define FONT_MANAGER_SOURCES_FILE_MONITORS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors))
#define FONT_MANAGER_SOURCES_FILE_MONITORS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitorsClass))
#define FONT_MANAGER_SOURCES_IS_FILE_MONITORS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS))
#define FONT_MANAGER_SOURCES_IS_FILE_MONITORS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS))
#define FONT_MANAGER_SOURCES_FILE_MONITORS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitorsClass))

typedef struct _FontManagerSourcesFileMonitors FontManagerSourcesFileMonitors;
typedef struct _FontManagerSourcesFileMonitorsClass FontManagerSourcesFileMonitorsClass;
enum  {
	FONT_MANAGER_SOURCES_0_PROPERTY,
	FONT_MANAGER_SOURCES_ACTIVE_PROPERTY,
	FONT_MANAGER_SOURCES_NUM_PROPERTIES
};
static GParamSpec* font_manager_sources_properties[FONT_MANAGER_SOURCES_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _FontManagerSourcesPurgeEntriesData FontManagerSourcesPurgeEntriesData;
typedef struct _FontManagerSourcesFileMonitorsPrivate FontManagerSourcesFileMonitorsPrivate;
enum  {
	FONT_MANAGER_SOURCES_FILE_MONITORS_0_PROPERTY,
	FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY,
	FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_PROPERTIES
};
static GParamSpec* font_manager_sources_file_monitors_properties[FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_PROPERTIES];
enum  {
	FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL,
	FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_SIGNALS
};
static guint font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerDefaultProperties {
	FontManagerProperties parent_instance;
	FontManagerDefaultPropertiesPrivate * priv;
};

struct _FontManagerDefaultPropertiesClass {
	FontManagerPropertiesClass parent_class;
};

struct _FontManagerDisplayProperties {
	FontManagerProperties parent_instance;
	FontManagerDisplayPropertiesPrivate * priv;
};

struct _FontManagerDisplayPropertiesClass {
	FontManagerPropertiesClass parent_class;
};

struct _FontManagerFontProperties {
	FontManagerDefaultProperties parent_instance;
	FontManagerFontPropertiesPrivate * priv;
};

struct _FontManagerFontPropertiesClass {
	FontManagerDefaultPropertiesClass parent_class;
};

struct _FontManagerFontPropertiesPrivate {
	gchar* _family;
	FontManagerFont* _font;
};

struct _FontManagerAccept {
	FontManagerSelections parent_instance;
	FontManagerAcceptPrivate * priv;
};

struct _FontManagerAcceptClass {
	FontManagerSelectionsClass parent_class;
};

struct _FontManagerDirectories {
	FontManagerSelections parent_instance;
	FontManagerDirectoriesPrivate * priv;
};

struct _FontManagerDirectoriesClass {
	FontManagerSelectionsClass parent_class;
};

struct _FontManagerReject {
	FontManagerSelections parent_instance;
	FontManagerRejectPrivate * priv;
};

struct _FontManagerRejectClass {
	FontManagerSelectionsClass parent_class;
};

struct _FontManagerSources {
	FontManagerDirectories parent_instance;
	FontManagerSourcesPrivate * priv;
};

struct _FontManagerSourcesClass {
	FontManagerDirectoriesClass parent_class;
};

struct _FontManagerSourcesPrivate {
	FontManagerDirectories* _active;
	FontManagerSourcesFileMonitors* monitors;
	GHashTable* sources;
};

struct _Block3Data {
	int _ref_count_;
	FontManagerSources* self;
	FontManagerSource* source;
};

struct _FontManagerSourcesPurgeEntriesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	FontManagerSources* self;
	gchar* path;
	FontManagerDatabaseType* types;
	FontManagerDatabaseType* _tmp0_;
	gint types_length1;
	gint _types_size_;
	FontManagerDatabase* db;
	FontManagerDatabase* _tmp1_;
	FontManagerDatabaseType* _tmp2_;
	gint _tmp2__length1;
	FontManagerDatabaseType* type_collection;
	gint type_collection_length1;
	gint _type_collection_size_;
	gint type_it;
	FontManagerDatabaseType type;
	gchar* name;
	FontManagerDatabaseType _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	FontManagerDatabase* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	FontManagerDatabase* _tmp10_;
	sqlite3_stmt* _tmp11_;
	FontManagerDatabaseType* _tmp12_;
	gint _tmp12__length1;
	FontManagerDatabaseType* _vala1_type_collection;
	gint _vala1_type_collection_length1;
	gint __vala1_type_collection_size_;
	gint _vala1_type_it;
	FontManagerDatabaseType _vala1_type;
	FontManagerDatabase* _tmp13_;
	FontManagerDatabaseType _tmp14_;
	FontManagerDatabase* _tmp15_;
	FontManagerDatabase* _tmp16_;
	FontManagerDatabase* _tmp17_;
	FontManagerDatabase* _tmp18_;
	sqlite3_stmt* _tmp19_;
	GError* e;
	GError* _tmp20_;
	GError* _tmp21_;
	const gchar* _tmp22_;
	GError* _inner_error0_;
};

struct _FontManagerSourcesFileMonitors {
	GObject parent_instance;
	FontManagerSourcesFileMonitorsPrivate * priv;
};

struct _FontManagerSourcesFileMonitorsClass {
	GObjectClass parent_class;
};

struct _FontManagerSourcesFileMonitorsPrivate {
	GVolumeMonitor* volume_monitor;
	GHashTable* monitors;
};

static gpointer font_manager_default_properties_parent_class = NULL;
static gpointer font_manager_display_properties_parent_class = NULL;
static gint FontManagerFontProperties_private_offset;
static gpointer font_manager_font_properties_parent_class = NULL;
static gpointer font_manager_accept_parent_class = NULL;
static gpointer font_manager_directories_parent_class = NULL;
static gpointer font_manager_reject_parent_class = NULL;
static gint FontManagerSources_private_offset;
static gpointer font_manager_sources_parent_class = NULL;
static gint FontManagerSourcesFileMonitors_private_offset;
static gpointer font_manager_sources_file_monitors_parent_class = NULL;

GType font_manager_width_get_type (void) G_GNUC_CONST;
gchar* font_manager_width_to_string (FontManagerWidth self);
GType font_manager_slant_get_type (void) G_GNUC_CONST;
gchar* font_manager_slant_to_string (FontManagerSlant self);
GType font_manager_weight_get_type (void) G_GNUC_CONST;
gboolean font_manager_weight_defined (FontManagerWeight self);
gchar* font_manager_weight_to_string (FontManagerWeight self);
GType font_manager_spacing_get_type (void) G_GNUC_CONST;
gchar* font_manager_spacing_to_string (FontManagerSpacing self);
GType font_manager_hint_style_get_type (void) G_GNUC_CONST;
gchar* font_manager_hint_style_to_string (FontManagerHintStyle self);
GType font_manager_lcd_filter_get_type (void) G_GNUC_CONST;
gchar* font_manager_lcd_filter_to_string (FontManagerLCDFilter self);
GType font_manager_subpixel_order_get_type (void) G_GNUC_CONST;
gchar* font_manager_subpixel_order_to_string (FontManagerSubpixelOrder self);
gboolean font_manager_load_user_font_resources (StringHashset* files,
                                                GList* sources);
GType font_manager_default_properties_get_type (void) G_GNUC_CONST;
FontManagerDefaultProperties* font_manager_default_properties_new (void);
FontManagerDefaultProperties* font_manager_default_properties_construct (GType object_type);
GType font_manager_display_properties_get_type (void) G_GNUC_CONST;
FontManagerDisplayProperties* font_manager_display_properties_new (void);
FontManagerDisplayProperties* font_manager_display_properties_construct (GType object_type);
GType font_manager_font_properties_get_type (void) G_GNUC_CONST;
FontManagerFontProperties* font_manager_font_properties_new (void);
FontManagerFontProperties* font_manager_font_properties_construct (GType object_type);
static void __lambda22_ (FontManagerFontProperties* self,
                  GObject* source,
                  GParamSpec* pspec);
static void ___lambda22__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda23_ (FontManagerFontProperties* self,
                  GObject* s,
                  GParamSpec* p);
gboolean font_manager_is_valid_source (FontManagerJsonProxy* object);
FontManagerFont* font_manager_font_properties_get_font (FontManagerFontProperties* self);
void font_manager_font_properties_set_family (FontManagerFontProperties* self,
                                              const gchar* value);
static void ___lambda23__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean font_manager_font_properties_real_load (FontManagerProperties* base);
const gchar* font_manager_font_properties_get_family (FontManagerFontProperties* self);
static void font_manager_font_properties_real_add_match_criteria (FontManagerProperties* base,
                                                           FontManagerXmlWriter* writer);
void font_manager_font_properties_set_font (FontManagerFontProperties* self,
                                            FontManagerFont* value);
static void font_manager_font_properties_finalize (GObject * obj);
static void _vala_font_manager_font_properties_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_font_manager_font_properties_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
GType font_manager_accept_get_type (void) G_GNUC_CONST;
FontManagerAccept* font_manager_accept_new (void);
FontManagerAccept* font_manager_accept_construct (GType object_type);
GType font_manager_directories_get_type (void) G_GNUC_CONST;
FontManagerDirectories* font_manager_directories_new (void);
FontManagerDirectories* font_manager_directories_construct (GType object_type);
static xmlNode* font_manager_directories_real_get_selections (FontManagerSelections* base,
                                                       xmlDoc* doc);
static void font_manager_directories_real_write_selections (FontManagerSelections* base,
                                                     FontManagerXmlWriter* writer);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
GType font_manager_reject_get_type (void) G_GNUC_CONST;
FontManagerReject* font_manager_reject_new (void);
FontManagerReject* font_manager_reject_construct (GType object_type);
static void __lambda24_ (FontManagerReject* self);
static gboolean __lambda25_ (FontManagerReject* self);
static gboolean ___lambda25__gsource_func (gpointer self);
static void ___lambda24__font_manager_selections_changed (FontManagerSelections* _sender,
                                                   gpointer self);
StringHashset* font_manager_reject_get_rejected_files (FontManagerReject* self);
GType font_manager_sources_get_type (void) G_GNUC_CONST;
GType font_manager_sources_file_monitors_get_type (void) G_GNUC_CONST;
FontManagerSources* font_manager_sources_new (void);
FontManagerSources* font_manager_sources_construct (GType object_type);
static void font_manager_sources_set_active (FontManagerSources* self,
                                      FontManagerDirectories* value);
FontManagerSourcesFileMonitors* font_manager_sources_file_monitors_new (void);
FontManagerSourcesFileMonitors* font_manager_sources_file_monitors_construct (GType object_type);
static void _g_object_unref0_ (gpointer var);
static void __lambda30_ (FontManagerSources* self,
                  GFile* f,
                  GFile* of,
                  GFileMonitorEvent ev);
void font_manager_sources_update (FontManagerSources* self);
static void ___lambda30__font_manager_sources_file_monitors_changed (FontManagerSourcesFileMonitors* _sender,
                                                              GFile* file,
                                                              GFile* other_file,
                                                              GFileMonitorEvent event_type,
                                                              gpointer self);
GList* font_manager_sources_list_objects (FontManagerSources* self);
FontManagerDirectories* font_manager_sources_get_active (FontManagerSources* self);
gboolean font_manager_sources_add_from_path (FontManagerSources* self,
                                             const gchar* dirpath);
gboolean font_manager_sources_add (FontManagerSources* self,
                                   FontManagerSource* source);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda31_ (Block3Data* _data3_);
static void font_manager_sources_source_activated (FontManagerSources* self,
                                            FontManagerSource* source);
static void ___lambda31__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
gboolean font_manager_sources_file_monitors_add (FontManagerSourcesFileMonitors* self,
                                                 const gchar* path);
static void font_manager_sources_purge_entries_data_free (gpointer _data);
static void font_manager_sources_purge_entries_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
void font_manager_sources_purge_entries (FontManagerSources* self,
                                         const gchar* path,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void font_manager_sources_purge_entries_finish (FontManagerSources* self,
                                                GAsyncResult* _res_);
static gboolean font_manager_sources_purge_entries_co (FontManagerSourcesPurgeEntriesData* _data_);
static gboolean _font_manager_sources_purge_entries_co_gsource_func (gpointer self);
gboolean font_manager_sources_remove (FontManagerSources* self,
                                      FontManagerSource* source);
gboolean font_manager_sources_file_monitors_remove (FontManagerSourcesFileMonitors* self,
                                                    const gchar* path);
static void __lambda32_ (FontManagerSources* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda32__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
gboolean font_manager_sources_load (FontManagerSources* self);
static void font_manager_sources_file_monitors_notify_on_mount_event (FontManagerSourcesFileMonitors* self,
                                                               GMount* mount);
guint font_manager_sources_file_monitors_get_size (FontManagerSourcesFileMonitors* self);
static void ___lambda26_ (FontManagerSourcesFileMonitors* self,
                   GFile* f,
                   GFile* of,
                   GFileMonitorEvent ev);
static void ____lambda26__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GObject * font_manager_sources_file_monitors_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties);
static void _font_manager_sources_file_monitors___lambda27_ (FontManagerSourcesFileMonitors* self,
                                                      GMount* m);
static void __font_manager_sources_file_monitors___lambda27__g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                                    GMount* mount,
                                                                                    gpointer self);
static void _font_manager_sources_file_monitors___lambda28_ (FontManagerSourcesFileMonitors* self,
                                                      GMount* m);
static void __font_manager_sources_file_monitors___lambda28__g_volume_monitor_mount_changed (GVolumeMonitor* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self);
static void _font_manager_sources_file_monitors___lambda29_ (FontManagerSourcesFileMonitors* self,
                                                      GMount* m);
static void __font_manager_sources_file_monitors___lambda29__g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self);
static void font_manager_sources_file_monitors_finalize (GObject * obj);
static void _vala_font_manager_sources_file_monitors_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void font_manager_sources_finalize (GObject * obj);
static void _vala_font_manager_sources_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_font_manager_sources_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

gchar*
font_manager_width_to_string (FontManagerWidth self)
{
	gchar* result = NULL;
	switch (self) {
		case FONT_MANAGER_WIDTH_ULTRACONDENSED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Ultra-Condensed"));
			result = _tmp0_;
			return result;
		}
		case FONT_MANAGER_WIDTH_EXTRACONDENSED:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Extra-Condensed"));
			result = _tmp1_;
			return result;
		}
		case FONT_MANAGER_WIDTH_CONDENSED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Condensed"));
			result = _tmp2_;
			return result;
		}
		case FONT_MANAGER_WIDTH_SEMICONDENSED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Semi-Condensed"));
			result = _tmp3_;
			return result;
		}
		case FONT_MANAGER_WIDTH_SEMIEXPANDED:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Semi-Expanded"));
			result = _tmp4_;
			return result;
		}
		case FONT_MANAGER_WIDTH_EXPANDED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Expanded"));
			result = _tmp5_;
			return result;
		}
		case FONT_MANAGER_WIDTH_EXTRAEXPANDED:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Extra-Expanded"));
			result = _tmp6_;
			return result;
		}
		case FONT_MANAGER_WIDTH_ULTRAEXPANDED:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Ultra-Expanded"));
			result = _tmp7_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}

GType
font_manager_width_get_type (void)
{
	static volatile gsize font_manager_width_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_width_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_WIDTH_ULTRACONDENSED, "FONT_MANAGER_WIDTH_ULTRACONDENSED", "ultracondensed"}, {FONT_MANAGER_WIDTH_EXTRACONDENSED, "FONT_MANAGER_WIDTH_EXTRACONDENSED", "extracondensed"}, {FONT_MANAGER_WIDTH_CONDENSED, "FONT_MANAGER_WIDTH_CONDENSED", "condensed"}, {FONT_MANAGER_WIDTH_SEMICONDENSED, "FONT_MANAGER_WIDTH_SEMICONDENSED", "semicondensed"}, {FONT_MANAGER_WIDTH_NORMAL, "FONT_MANAGER_WIDTH_NORMAL", "normal"}, {FONT_MANAGER_WIDTH_SEMIEXPANDED, "FONT_MANAGER_WIDTH_SEMIEXPANDED", "semiexpanded"}, {FONT_MANAGER_WIDTH_EXPANDED, "FONT_MANAGER_WIDTH_EXPANDED", "expanded"}, {FONT_MANAGER_WIDTH_EXTRAEXPANDED, "FONT_MANAGER_WIDTH_EXTRAEXPANDED", "extraexpanded"}, {FONT_MANAGER_WIDTH_ULTRAEXPANDED, "FONT_MANAGER_WIDTH_ULTRAEXPANDED", "ultraexpanded"}, {0, NULL, NULL}};
		GType font_manager_width_type_id;
		font_manager_width_type_id = g_enum_register_static ("FontManagerWidth", values);
		g_once_init_leave (&font_manager_width_type_id__volatile, font_manager_width_type_id);
	}
	return font_manager_width_type_id__volatile;
}

gchar*
font_manager_slant_to_string (FontManagerSlant self)
{
	gchar* result = NULL;
	switch (self) {
		case FONT_MANAGER_SLANT_ITALIC:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Italic"));
			result = _tmp0_;
			return result;
		}
		case FONT_MANAGER_SLANT_OBLIQUE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Oblique"));
			result = _tmp1_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}

GType
font_manager_slant_get_type (void)
{
	static volatile gsize font_manager_slant_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_slant_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_SLANT_ROMAN, "FONT_MANAGER_SLANT_ROMAN", "roman"}, {FONT_MANAGER_SLANT_ITALIC, "FONT_MANAGER_SLANT_ITALIC", "italic"}, {FONT_MANAGER_SLANT_OBLIQUE, "FONT_MANAGER_SLANT_OBLIQUE", "oblique"}, {0, NULL, NULL}};
		GType font_manager_slant_type_id;
		font_manager_slant_type_id = g_enum_register_static ("FontManagerSlant", values);
		g_once_init_leave (&font_manager_slant_type_id__volatile, font_manager_slant_type_id);
	}
	return font_manager_slant_type_id__volatile;
}

gboolean
font_manager_weight_defined (FontManagerWeight self)
{
	gboolean result = FALSE;
	gboolean res = FALSE;
	switch (self) {
		case FONT_MANAGER_WEIGHT_THIN:
		case FONT_MANAGER_WEIGHT_ULTRALIGHT:
		case FONT_MANAGER_WEIGHT_LIGHT:
		case FONT_MANAGER_WEIGHT_BOOK:
		case FONT_MANAGER_WEIGHT_REGULAR:
		case FONT_MANAGER_WEIGHT_MEDIUM:
		case FONT_MANAGER_WEIGHT_SEMIBOLD:
		case FONT_MANAGER_WEIGHT_BOLD:
		case FONT_MANAGER_WEIGHT_EXTRABOLD:
		case FONT_MANAGER_WEIGHT_BLACK:
		case FONT_MANAGER_WEIGHT_ULTRABLACK:
		{
			res = TRUE;
			break;
		}
		default:
		{
			res = FALSE;
			break;
		}
	}
	result = res;
	return result;
}

gchar*
font_manager_weight_to_string (FontManagerWeight self)
{
	gchar* result = NULL;
	switch (self) {
		case FONT_MANAGER_WEIGHT_THIN:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Thin"));
			result = _tmp0_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_ULTRALIGHT:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Ultra-Light"));
			result = _tmp1_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_LIGHT:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Light"));
			result = _tmp2_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_BOOK:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Book"));
			result = _tmp3_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_MEDIUM:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Medium"));
			result = _tmp4_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_SEMIBOLD:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Semi-Bold"));
			result = _tmp5_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_BOLD:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Bold"));
			result = _tmp6_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_EXTRABOLD:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("Ultra-Bold"));
			result = _tmp7_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_HEAVY:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup (_ ("Heavy"));
			result = _tmp8_;
			return result;
		}
		case FONT_MANAGER_WEIGHT_ULTRABLACK:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup (_ ("Ultra-Heavy"));
			result = _tmp9_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}

GType
font_manager_weight_get_type (void)
{
	static volatile gsize font_manager_weight_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_weight_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_WEIGHT_THIN, "FONT_MANAGER_WEIGHT_THIN", "thin"}, {FONT_MANAGER_WEIGHT_EXTRALIGHT, "FONT_MANAGER_WEIGHT_EXTRALIGHT", "extralight"}, {FONT_MANAGER_WEIGHT_ULTRALIGHT, "FONT_MANAGER_WEIGHT_ULTRALIGHT", "ultralight"}, {FONT_MANAGER_WEIGHT_LIGHT, "FONT_MANAGER_WEIGHT_LIGHT", "light"}, {FONT_MANAGER_WEIGHT_BOOK, "FONT_MANAGER_WEIGHT_BOOK", "book"}, {FONT_MANAGER_WEIGHT_REGULAR, "FONT_MANAGER_WEIGHT_REGULAR", "regular"}, {FONT_MANAGER_WEIGHT_NORMAL, "FONT_MANAGER_WEIGHT_NORMAL", "normal"}, {FONT_MANAGER_WEIGHT_MEDIUM, "FONT_MANAGER_WEIGHT_MEDIUM", "medium"}, {FONT_MANAGER_WEIGHT_DEMIBOLD, "FONT_MANAGER_WEIGHT_DEMIBOLD", "demibold"}, {FONT_MANAGER_WEIGHT_SEMIBOLD, "FONT_MANAGER_WEIGHT_SEMIBOLD", "semibold"}, {FONT_MANAGER_WEIGHT_BOLD, "FONT_MANAGER_WEIGHT_BOLD", "bold"}, {FONT_MANAGER_WEIGHT_EXTRABOLD, "FONT_MANAGER_WEIGHT_EXTRABOLD", "extrabold"}, {FONT_MANAGER_WEIGHT_BLACK, "FONT_MANAGER_WEIGHT_BLACK", "black"}, {FONT_MANAGER_WEIGHT_HEAVY, "FONT_MANAGER_WEIGHT_HEAVY", "heavy"}, {FONT_MANAGER_WEIGHT_EXTRABLACK, "FONT_MANAGER_WEIGHT_EXTRABLACK", "extrablack"}, {FONT_MANAGER_WEIGHT_ULTRABLACK, "FONT_MANAGER_WEIGHT_ULTRABLACK", "ultrablack"}, {0, NULL, NULL}};
		GType font_manager_weight_type_id;
		font_manager_weight_type_id = g_enum_register_static ("FontManagerWeight", values);
		g_once_init_leave (&font_manager_weight_type_id__volatile, font_manager_weight_type_id);
	}
	return font_manager_weight_type_id__volatile;
}

gchar*
font_manager_spacing_to_string (FontManagerSpacing self)
{
	gchar* result = NULL;
	switch (self) {
		case FONT_MANAGER_SPACING_PROPORTIONAL:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Proportional"));
			result = _tmp0_;
			return result;
		}
		case FONT_MANAGER_SPACING_DUAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Dual Width"));
			result = _tmp1_;
			return result;
		}
		case FONT_MANAGER_SPACING_MONO:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Monospace"));
			result = _tmp2_;
			return result;
		}
		case FONT_MANAGER_SPACING_CHARCELL:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Charcell"));
			result = _tmp3_;
			return result;
		}
		default:
		{
			result = NULL;
			return result;
		}
	}
}

GType
font_manager_spacing_get_type (void)
{
	static volatile gsize font_manager_spacing_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_spacing_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_SPACING_PROPORTIONAL, "FONT_MANAGER_SPACING_PROPORTIONAL", "proportional"}, {FONT_MANAGER_SPACING_DUAL, "FONT_MANAGER_SPACING_DUAL", "dual"}, {FONT_MANAGER_SPACING_MONO, "FONT_MANAGER_SPACING_MONO", "mono"}, {FONT_MANAGER_SPACING_CHARCELL, "FONT_MANAGER_SPACING_CHARCELL", "charcell"}, {0, NULL, NULL}};
		GType font_manager_spacing_type_id;
		font_manager_spacing_type_id = g_enum_register_static ("FontManagerSpacing", values);
		g_once_init_leave (&font_manager_spacing_type_id__volatile, font_manager_spacing_type_id);
	}
	return font_manager_spacing_type_id__volatile;
}

gchar*
font_manager_hint_style_to_string (FontManagerHintStyle self)
{
	gchar* result = NULL;
	switch (self) {
		case FONT_MANAGER_HINT_STYLE_SLIGHT:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Slight"));
			result = _tmp0_;
			return result;
		}
		case FONT_MANAGER_HINT_STYLE_MEDIUM:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Medium"));
			result = _tmp1_;
			return result;
		}
		case FONT_MANAGER_HINT_STYLE_FULL:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Full"));
			result = _tmp2_;
			return result;
		}
		default:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("None"));
			result = _tmp3_;
			return result;
		}
	}
}

GType
font_manager_hint_style_get_type (void)
{
	static volatile gsize font_manager_hint_style_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_hint_style_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_HINT_STYLE_NONE, "FONT_MANAGER_HINT_STYLE_NONE", "none"}, {FONT_MANAGER_HINT_STYLE_SLIGHT, "FONT_MANAGER_HINT_STYLE_SLIGHT", "slight"}, {FONT_MANAGER_HINT_STYLE_MEDIUM, "FONT_MANAGER_HINT_STYLE_MEDIUM", "medium"}, {FONT_MANAGER_HINT_STYLE_FULL, "FONT_MANAGER_HINT_STYLE_FULL", "full"}, {0, NULL, NULL}};
		GType font_manager_hint_style_type_id;
		font_manager_hint_style_type_id = g_enum_register_static ("FontManagerHintStyle", values);
		g_once_init_leave (&font_manager_hint_style_type_id__volatile, font_manager_hint_style_type_id);
	}
	return font_manager_hint_style_type_id__volatile;
}

gchar*
font_manager_lcd_filter_to_string (FontManagerLCDFilter self)
{
	gchar* result = NULL;
	switch (self) {
		case FONT_MANAGER_LCD_FILTER_DEFAULT:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Default"));
			result = _tmp0_;
			return result;
		}
		case FONT_MANAGER_LCD_FILTER_LIGHT:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Light"));
			result = _tmp1_;
			return result;
		}
		case FONT_MANAGER_LCD_FILTER_LEGACY:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Legacy"));
			result = _tmp2_;
			return result;
		}
		default:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("None"));
			result = _tmp3_;
			return result;
		}
	}
}

GType
font_manager_lcd_filter_get_type (void)
{
	static volatile gsize font_manager_lcd_filter_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_lcd_filter_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_LCD_FILTER_NONE, "FONT_MANAGER_LCD_FILTER_NONE", "none"}, {FONT_MANAGER_LCD_FILTER_DEFAULT, "FONT_MANAGER_LCD_FILTER_DEFAULT", "default"}, {FONT_MANAGER_LCD_FILTER_LIGHT, "FONT_MANAGER_LCD_FILTER_LIGHT", "light"}, {FONT_MANAGER_LCD_FILTER_LEGACY, "FONT_MANAGER_LCD_FILTER_LEGACY", "legacy"}, {0, NULL, NULL}};
		GType font_manager_lcd_filter_type_id;
		font_manager_lcd_filter_type_id = g_enum_register_static ("FontManagerLCDFilter", values);
		g_once_init_leave (&font_manager_lcd_filter_type_id__volatile, font_manager_lcd_filter_type_id);
	}
	return font_manager_lcd_filter_type_id__volatile;
}

gchar*
font_manager_subpixel_order_to_string (FontManagerSubpixelOrder self)
{
	gchar* result = NULL;
	switch (self) {
		case FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Unknown"));
			result = _tmp0_;
			return result;
		}
		case FONT_MANAGER_SUBPIXEL_ORDER_RGB:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("RGB"));
			result = _tmp1_;
			return result;
		}
		case FONT_MANAGER_SUBPIXEL_ORDER_BGR:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("BGR"));
			result = _tmp2_;
			return result;
		}
		case FONT_MANAGER_SUBPIXEL_ORDER_VRGB:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("VRGB"));
			result = _tmp3_;
			return result;
		}
		case FONT_MANAGER_SUBPIXEL_ORDER_VBGR:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("VBGR"));
			result = _tmp4_;
			return result;
		}
		default:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("None"));
			result = _tmp5_;
			return result;
		}
	}
}

GType
font_manager_subpixel_order_get_type (void)
{
	static volatile gsize font_manager_subpixel_order_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_subpixel_order_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN, "FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN", "unknown"}, {FONT_MANAGER_SUBPIXEL_ORDER_RGB, "FONT_MANAGER_SUBPIXEL_ORDER_RGB", "rgb"}, {FONT_MANAGER_SUBPIXEL_ORDER_BGR, "FONT_MANAGER_SUBPIXEL_ORDER_BGR", "bgr"}, {FONT_MANAGER_SUBPIXEL_ORDER_VRGB, "FONT_MANAGER_SUBPIXEL_ORDER_VRGB", "vrgb"}, {FONT_MANAGER_SUBPIXEL_ORDER_VBGR, "FONT_MANAGER_SUBPIXEL_ORDER_VBGR", "vbgr"}, {FONT_MANAGER_SUBPIXEL_ORDER_NONE, "FONT_MANAGER_SUBPIXEL_ORDER_NONE", "none"}, {0, NULL, NULL}};
		GType font_manager_subpixel_order_type_id;
		font_manager_subpixel_order_type_id = g_enum_register_static ("FontManagerSubpixelOrder", values);
		g_once_init_leave (&font_manager_subpixel_order_type_id__volatile, font_manager_subpixel_order_type_id);
	}
	return font_manager_subpixel_order_type_id__volatile;
}

/**
     * load_user_font_resources:
     *
     * Adds user configured font sources (directories) and rejected fonts to our
     * FcConfig so that we can render fonts which are not actually "installed".
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
font_manager_load_user_font_resources (StringHashset* files,
                                       GList* sources)
{
	gboolean result = FALSE;
	gboolean res = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	clear_application_fonts ();
	res = TRUE;
	_tmp0_ = get_user_font_directory ();
	_tmp1_ = _tmp0_;
	_tmp2_ = !add_application_font_directory (_tmp1_);
	_g_free0 (_tmp1_);
	if (_tmp2_) {
		res = FALSE;
		g_critical ("FontConfig.vala:257: Failed to add default user font directory to conf" \
"iguration!");
	}
	{
		GList* source_collection = NULL;
		GList* source_it = NULL;
		source_collection = sources;
		for (source_it = source_collection; source_it != NULL; source_it = source_it->next) {
			FontManagerSource* _tmp3_;
			FontManagerSource* source = NULL;
			_tmp3_ = _g_object_ref0 ((FontManagerSource*) source_it->data);
			source = _tmp3_;
			{
				gboolean _tmp4_ = FALSE;
				FontManagerSource* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
				_tmp5_ = source;
				g_object_get (_tmp5_, "available", &_tmp6_, NULL);
				_tmp7_ = _tmp6_;
				if (_tmp7_) {
					FontManagerSource* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					_tmp8_ = source;
					g_object_get (_tmp8_, "path", &_tmp9_, NULL);
					_tmp10_ = _tmp9_;
					_tmp11_ = _tmp10_;
					_tmp4_ = !add_application_font_directory (_tmp11_);
					_g_free0 (_tmp11_);
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					FontManagerSource* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					res = FALSE;
					_tmp12_ = source;
					g_object_get (_tmp12_, "path", &_tmp13_, NULL);
					_tmp14_ = _tmp13_;
					_tmp15_ = _tmp14_;
					g_warning ("FontConfig.vala:262: Failed to register user font source! : %s", _tmp15_);
					_g_free0 (_tmp15_);
				}
				_g_object_unref0 (source);
			}
		}
	}
	if (files != NULL) {
		{
			StringHashset* _path_list = NULL;
			StringHashset* _tmp16_;
			guint _path_size = 0U;
			StringHashset* _tmp17_;
			guint _tmp18_;
			guint _tmp19_;
			gint _path_index = 0;
			_tmp16_ = _g_object_ref0 (files);
			_path_list = _tmp16_;
			_tmp17_ = _path_list;
			g_object_get (_tmp17_, "size", &_tmp18_, NULL);
			_tmp19_ = _tmp18_;
			_path_size = _tmp19_;
			_path_index = -1;
			while (TRUE) {
				gchar* path = NULL;
				StringHashset* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				const gchar* _tmp23_;
				_path_index = _path_index + 1;
				if (!(((guint) _path_index) < _path_size)) {
					break;
				}
				_tmp20_ = _path_list;
				_tmp21_ = string_hashset_get (_tmp20_, (guint) _path_index);
				_tmp22_ = g_strdup (_tmp21_);
				path = _tmp22_;
				_tmp23_ = path;
				add_application_font (_tmp23_);
				_g_free0 (path);
			}
			_g_object_unref0 (_path_list);
		}
	}
	result = res;
	return result;
}

FontManagerDefaultProperties*
font_manager_default_properties_construct (GType object_type)
{
	FontManagerDefaultProperties * self = NULL;
	self = (FontManagerDefaultProperties*) g_object_new (object_type, NULL);
	g_object_set ((FontManagerProperties*) self, "type", (gint) FONT_MANAGER_PROPERTIES_TYPE_DEFAULT, NULL);
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DefaultProperties.conf", NULL);
	font_manager_properties_load ((FontManagerProperties*) self);
	return self;
}

FontManagerDefaultProperties*
font_manager_default_properties_new (void)
{
	return font_manager_default_properties_construct (FONT_MANAGER_TYPE_DEFAULT_PROPERTIES);
}

static void
font_manager_default_properties_class_init (FontManagerDefaultPropertiesClass * klass,
                                            gpointer klass_data)
{
	font_manager_default_properties_parent_class = g_type_class_peek_parent (klass);
}

static void
font_manager_default_properties_instance_init (FontManagerDefaultProperties * self,
                                               gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_default_properties_get_type (void)
{
	static volatile gsize font_manager_default_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_default_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerDefaultPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_default_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerDefaultProperties), 0, (GInstanceInitFunc) font_manager_default_properties_instance_init, NULL };
		GType font_manager_default_properties_type_id;
		font_manager_default_properties_type_id = g_type_register_static (font_manager_properties_get_type (), "FontManagerDefaultProperties", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_default_properties_type_id__volatile, font_manager_default_properties_type_id);
	}
	return font_manager_default_properties_type_id__volatile;
}

FontManagerDisplayProperties*
font_manager_display_properties_construct (GType object_type)
{
	FontManagerDisplayProperties * self = NULL;
	self = (FontManagerDisplayProperties*) g_object_new (object_type, NULL);
	g_object_set ((FontManagerProperties*) self, "type", (gint) FONT_MANAGER_PROPERTIES_TYPE_DISPLAY, NULL);
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DisplayProperties.conf", NULL);
	font_manager_properties_load ((FontManagerProperties*) self);
	return self;
}

FontManagerDisplayProperties*
font_manager_display_properties_new (void)
{
	return font_manager_display_properties_construct (FONT_MANAGER_TYPE_DISPLAY_PROPERTIES);
}

static void
font_manager_display_properties_class_init (FontManagerDisplayPropertiesClass * klass,
                                            gpointer klass_data)
{
	font_manager_display_properties_parent_class = g_type_class_peek_parent (klass);
}

static void
font_manager_display_properties_instance_init (FontManagerDisplayProperties * self,
                                               gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_display_properties_get_type (void)
{
	static volatile gsize font_manager_display_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_display_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerDisplayPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_display_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerDisplayProperties), 0, (GInstanceInitFunc) font_manager_display_properties_instance_init, NULL };
		GType font_manager_display_properties_type_id;
		font_manager_display_properties_type_id = g_type_register_static (font_manager_properties_get_type (), "FontManagerDisplayProperties", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_display_properties_type_id__volatile, font_manager_display_properties_type_id);
	}
	return font_manager_display_properties_type_id__volatile;
}

static inline gpointer
font_manager_font_properties_get_instance_private (FontManagerFontProperties* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerFontProperties_private_offset);
}

static void
__lambda22_ (FontManagerFontProperties* self,
             GObject* source,
             GParamSpec* pspec)
{
	g_return_if_fail (source != NULL);
	g_return_if_fail (pspec != NULL);
	font_manager_properties_load ((FontManagerProperties*) self);
	g_signal_emit (self, font_manager_font_properties_signals[FONT_MANAGER_FONT_PROPERTIES_CHANGED_SIGNAL], 0);
}

static void
___lambda22__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda22_ ((FontManagerFontProperties*) self, _sender, pspec);
}

static void
__lambda23_ (FontManagerFontProperties* self,
             GObject* s,
             GParamSpec* p)
{
	gchar* _tmp0_ = NULL;
	FontManagerFont* _tmp1_;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	_tmp1_ = self->priv->_font;
	if (font_manager_is_valid_source ((FontManagerJsonProxy*) _tmp1_)) {
		FontManagerFont* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = self->priv->_font;
		g_object_get (_tmp2_, "family", &_tmp3_, NULL);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp4_;
	} else {
		_g_free0 (_tmp0_);
		_tmp0_ = NULL;
	}
	font_manager_font_properties_set_family (self, _tmp0_);
	_g_free0 (_tmp0_);
}

static void
___lambda23__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda23_ ((FontManagerFontProperties*) self, _sender, pspec);
}

FontManagerFontProperties*
font_manager_font_properties_construct (GType object_type)
{
	FontManagerFontProperties * self = NULL;
	self = (FontManagerFontProperties*) font_manager_default_properties_construct (object_type);
	g_object_set ((FontManagerProperties*) self, "type", (gint) FONT_MANAGER_PROPERTIES_TYPE_DEFAULT, NULL);
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DefaultProperties.conf", NULL);
	g_signal_connect_object ((GObject*) self, "notify::family", (GCallback) ___lambda22__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::font", (GCallback) ___lambda23__g_object_notify, self, 0);
	font_manager_properties_load ((FontManagerProperties*) self);
	return self;
}

FontManagerFontProperties*
font_manager_font_properties_new (void)
{
	return font_manager_font_properties_construct (FONT_MANAGER_TYPE_FONT_PROPERTIES);
}

/**
         * {@inheritDoc}
         */
static gboolean
font_manager_font_properties_real_load (FontManagerProperties* base)
{
	FontManagerFontProperties * self;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	FontManagerFont* _tmp4_;
	self = (FontManagerFontProperties*) base;
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DefaultProperties.conf", NULL);
	FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->load ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties));
	_tmp0_ = self->priv->_family;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = self->priv->_family;
		_tmp2_ = g_strdup_printf ("29-%s.conf", _tmp1_);
		_tmp3_ = _tmp2_;
		g_object_set ((FontManagerProperties*) self, "target-file", _tmp3_, NULL);
		_g_free0 (_tmp3_);
		FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->load ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties));
	}
	_tmp4_ = self->priv->_font;
	if (font_manager_is_valid_source ((FontManagerJsonProxy*) _tmp4_)) {
		FontManagerFont* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp5_ = self->priv->_font;
		g_object_get (_tmp5_, "description", &_tmp6_, NULL);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_;
		_tmp9_ = to_filename (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup_printf ("29-%s.conf", _tmp10_);
		_tmp12_ = _tmp11_;
		g_object_set ((FontManagerProperties*) self, "target-file", _tmp12_, NULL);
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->load ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties));
	}
	result = TRUE;
	return result;
}

/**
         * {@inheritDoc}
         */
static void
font_manager_font_properties_real_add_match_criteria (FontManagerProperties* base,
                                                      FontManagerXmlWriter* writer)
{
	FontManagerFontProperties * self;
	const gchar* _tmp0_;
	FontManagerFont* _tmp2_;
	self = (FontManagerFontProperties*) base;
	g_return_if_fail (writer != NULL);
	_tmp0_ = self->priv->_family;
	if (_tmp0_ != NULL) {
		const gchar* _tmp1_;
		_tmp1_ = self->priv->_family;
		font_manager_xml_writer_add_test_element (writer, "family", "contains", "string", _tmp1_);
	}
	_tmp2_ = self->priv->_font;
	if (font_manager_is_valid_source ((FontManagerJsonProxy*) _tmp2_)) {
		FontManagerFont* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		FontManagerFont* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		FontManagerFont* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		_tmp3_ = self->priv->_font;
		g_object_get (_tmp3_, "slant", &_tmp4_, NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup_printf ("%i", _tmp5_);
		_tmp7_ = _tmp6_;
		font_manager_xml_writer_add_test_element (writer, "slant", "eq", "int", _tmp7_);
		_g_free0 (_tmp7_);
		_tmp8_ = self->priv->_font;
		g_object_get (_tmp8_, "weight", &_tmp9_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup_printf ("%i", _tmp10_);
		_tmp12_ = _tmp11_;
		font_manager_xml_writer_add_test_element (writer, "weight", "eq", "int", _tmp12_);
		_g_free0 (_tmp12_);
		_tmp13_ = self->priv->_font;
		g_object_get (_tmp13_, "width", &_tmp14_, NULL);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strdup_printf ("%i", _tmp15_);
		_tmp17_ = _tmp16_;
		font_manager_xml_writer_add_test_element (writer, "width", "eq", "int", _tmp17_);
		_g_free0 (_tmp17_);
	}
	FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->add_match_criteria ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties), writer);
	return;
}

const gchar*
font_manager_font_properties_get_family (FontManagerFontProperties* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_family;
	result = _tmp0_;
	return result;
}

void
font_manager_font_properties_set_family (FontManagerFontProperties* self,
                                         const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, font_manager_font_properties_get_family (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_family);
		self->priv->_family = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY]);
	}
}

FontManagerFont*
font_manager_font_properties_get_font (FontManagerFontProperties* self)
{
	FontManagerFont* result;
	FontManagerFont* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_font;
	result = _tmp0_;
	return result;
}

void
font_manager_font_properties_set_font (FontManagerFontProperties* self,
                                       FontManagerFont* value)
{
	g_return_if_fail (self != NULL);
	if (font_manager_font_properties_get_font (self) != value) {
		FontManagerFont* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_font);
		self->priv->_font = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY]);
	}
}

static void
font_manager_font_properties_class_init (FontManagerFontPropertiesClass * klass,
                                         gpointer klass_data)
{
	font_manager_font_properties_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerFontProperties_private_offset);
	((FontManagerPropertiesClass *) klass)->load = (gboolean (*) (FontManagerProperties*)) font_manager_font_properties_real_load;
	((FontManagerPropertiesClass *) klass)->add_match_criteria = (void (*) (FontManagerProperties*, FontManagerXmlWriter*)) font_manager_font_properties_real_add_match_criteria;
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_font_properties_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_font_properties_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_manager_font_properties_finalize;
	/**
	         * FontProperties:family:
	         *
	         * Name of font family this configuration will apply to.
	         * If only family is set, configuration will apply to all variations.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * FontProperties:font:
	         *
	         * #Font this configuration will apply to.
	         * If font is set, configuration will apply only to that specific variation.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY] = g_param_spec_object ("font", "font", "font", font_manager_font_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	         * FontProperties:changed:
	         *
	         * Emitted whenever family or font changes.
	         */
	font_manager_font_properties_signals[FONT_MANAGER_FONT_PROPERTIES_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_TYPE_FONT_PROPERTIES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
font_manager_font_properties_instance_init (FontManagerFontProperties * self,
                                            gpointer klass)
{
	self->priv = font_manager_font_properties_get_instance_private (self);
	self->priv->_family = NULL;
	self->priv->_font = NULL;
}

static void
font_manager_font_properties_finalize (GObject * obj)
{
	FontManagerFontProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties);
	_g_free0 (self->priv->_family);
	_g_object_unref0 (self->priv->_font);
	G_OBJECT_CLASS (font_manager_font_properties_parent_class)->finalize (obj);
}

/**
     * {@inheritDoc}
     */
GType
font_manager_font_properties_get_type (void)
{
	static volatile gsize font_manager_font_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_font_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerFontPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_font_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerFontProperties), 0, (GInstanceInitFunc) font_manager_font_properties_instance_init, NULL };
		GType font_manager_font_properties_type_id;
		font_manager_font_properties_type_id = g_type_register_static (FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, "FontManagerFontProperties", &g_define_type_info, 0);
		FontManagerFontProperties_private_offset = g_type_add_instance_private (font_manager_font_properties_type_id, sizeof (FontManagerFontPropertiesPrivate));
		g_once_init_leave (&font_manager_font_properties_type_id__volatile, font_manager_font_properties_type_id);
	}
	return font_manager_font_properties_type_id__volatile;
}

static void
_vala_font_manager_font_properties_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	FontManagerFontProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties);
	switch (property_id) {
		case FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY:
		g_value_set_string (value, font_manager_font_properties_get_family (self));
		break;
		case FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY:
		g_value_set_object (value, font_manager_font_properties_get_font (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_font_properties_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	FontManagerFontProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties);
	switch (property_id) {
		case FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY:
		font_manager_font_properties_set_family (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY:
		font_manager_font_properties_set_font (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

FontManagerAccept*
font_manager_accept_construct (GType object_type)
{
	FontManagerAccept * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	self = (FontManagerAccept*) g_object_new (object_type, NULL);
	_tmp0_ = get_user_fontconfig_directory ();
	_tmp1_ = _tmp0_;
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
	_g_free0 (_tmp1_);
	g_object_set ((FontManagerSelections*) self, "target-element", "acceptfont", NULL);
	g_object_set ((FontManagerSelections*) self, "target-file", "79-Accept.conf", NULL);
	return self;
}

FontManagerAccept*
font_manager_accept_new (void)
{
	return font_manager_accept_construct (FONT_MANAGER_TYPE_ACCEPT);
}

static void
font_manager_accept_class_init (FontManagerAcceptClass * klass,
                                gpointer klass_data)
{
	font_manager_accept_parent_class = g_type_class_peek_parent (klass);
}

static void
font_manager_accept_instance_init (FontManagerAccept * self,
                                   gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_accept_get_type (void)
{
	static volatile gsize font_manager_accept_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_accept_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerAcceptClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_accept_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerAccept), 0, (GInstanceInitFunc) font_manager_accept_instance_init, NULL };
		GType font_manager_accept_type_id;
		font_manager_accept_type_id = g_type_register_static (font_manager_selections_get_type (), "FontManagerAccept", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_accept_type_id__volatile, font_manager_accept_type_id);
	}
	return font_manager_accept_type_id__volatile;
}

FontManagerDirectories*
font_manager_directories_construct (GType object_type)
{
	FontManagerDirectories * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	self = (FontManagerDirectories*) g_object_new (object_type, NULL);
	_tmp0_ = get_user_fontconfig_directory ();
	_tmp1_ = _tmp0_;
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
	_g_free0 (_tmp1_);
	g_object_set ((FontManagerSelections*) self, "target-element", "dir", NULL);
	g_object_set ((FontManagerSelections*) self, "target-file", "09-Directories.conf", NULL);
	return self;
}

FontManagerDirectories*
font_manager_directories_new (void)
{
	return font_manager_directories_construct (FONT_MANAGER_TYPE_DIRECTORIES);
}

/**
         * {@inheritDoc}
         */
static xmlNode*
font_manager_directories_real_get_selections (FontManagerSelections* base,
                                              xmlDoc* doc)
{
	FontManagerDirectories * self;
	xmlNode* result = NULL;
	xmlNode* root = NULL;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_ = NULL;
	xmlNode* _tmp2_;
	self = (FontManagerDirectories*) base;
	_tmp0_ = xmlDocGetRootElement (doc);
	root = _tmp0_;
	_tmp2_ = root;
	if (_tmp2_ != NULL) {
		xmlNode* _tmp3_;
		xmlNode* _tmp4_;
		_tmp3_ = root;
		_tmp4_ = _tmp3_->children;
		_tmp1_ = _tmp4_;
	} else {
		_tmp1_ = NULL;
	}
	result = _tmp1_;
	return result;
}

/**
         * {@inheritDoc}
         */
static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
font_manager_directories_real_write_selections (FontManagerSelections* base,
                                                FontManagerXmlWriter* writer)
{
	FontManagerDirectories * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	self = (FontManagerDirectories*) base;
	g_return_if_fail (writer != NULL);
	g_object_get ((FontManagerSelections*) self, "target-element", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = string_hashset_list ((StringHashset*) self);
	_tmp4_ = _tmp3_;
	font_manager_xml_writer_add_elements (writer, _tmp2_, _tmp4_);
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_free0_ (_tmp4_), NULL));
	_g_free0 (_tmp2_);
	return;
}

static void
font_manager_directories_class_init (FontManagerDirectoriesClass * klass,
                                     gpointer klass_data)
{
	font_manager_directories_parent_class = g_type_class_peek_parent (klass);
	((FontManagerSelectionsClass *) klass)->get_selections = (xmlNode* (*) (FontManagerSelections*, xmlDoc*)) font_manager_directories_real_get_selections;
	((FontManagerSelectionsClass *) klass)->write_selections = (void (*) (FontManagerSelections*, FontManagerXmlWriter*)) font_manager_directories_real_write_selections;
}

static void
font_manager_directories_instance_init (FontManagerDirectories * self,
                                        gpointer klass)
{
}

/**
     * Directories - Represents a Fontconfig configuration file
     *
     * <dir> elements contain a directory path which will be scanned
     * for font files to include in the set of available fonts.
     */
GType
font_manager_directories_get_type (void)
{
	static volatile gsize font_manager_directories_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_directories_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerDirectoriesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_directories_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerDirectories), 0, (GInstanceInitFunc) font_manager_directories_instance_init, NULL };
		GType font_manager_directories_type_id;
		font_manager_directories_type_id = g_type_register_static (font_manager_selections_get_type (), "FontManagerDirectories", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_directories_type_id__volatile, font_manager_directories_type_id);
	}
	return font_manager_directories_type_id__volatile;
}

static gboolean
__lambda25_ (FontManagerReject* self)
{
	gboolean result = FALSE;
	font_manager_selections_load ((FontManagerSelections*) self);
	result = FALSE;
	return result;
}

static gboolean
___lambda25__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda25_ ((FontManagerReject*) self);
	return result;
}

static void
__lambda24_ (FontManagerReject* self)
{
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 3, ___lambda25__gsource_func, g_object_ref (self), g_object_unref);
}

static void
___lambda24__font_manager_selections_changed (FontManagerSelections* _sender,
                                              gpointer self)
{
	__lambda24_ ((FontManagerReject*) self);
}

FontManagerReject*
font_manager_reject_construct (GType object_type)
{
	FontManagerReject * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	self = (FontManagerReject*) g_object_new (object_type, NULL);
	_tmp0_ = get_user_fontconfig_directory ();
	_tmp1_ = _tmp0_;
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
	_g_free0 (_tmp1_);
	g_object_set ((FontManagerSelections*) self, "target-element", "rejectfont", NULL);
	g_object_set ((FontManagerSelections*) self, "target-file", "78-Reject.conf", NULL);
	g_signal_connect_object ((FontManagerSelections*) self, "changed", (GCallback) ___lambda24__font_manager_selections_changed, self, 0);
	return self;
}

FontManagerReject*
font_manager_reject_new (void)
{
	return font_manager_reject_construct (FONT_MANAGER_TYPE_REJECT);
}

StringHashset*
font_manager_reject_get_rejected_files (FontManagerReject* self)
{
	StringHashset* result = NULL;
	StringHashset* results = NULL;
	StringHashset* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = string_hashset_new ();
	results = _tmp0_;
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp1_;
		_tmp1_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_FONT, &_inner_error0_);
		db = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch6_g_error;
		}
		{
			FontManagerReject* _family_list = NULL;
			FontManagerReject* _tmp2_;
			guint _family_size = 0U;
			FontManagerReject* _tmp3_;
			guint _tmp4_;
			guint _tmp5_;
			gint _family_index = 0;
			_tmp2_ = _g_object_ref0 (self);
			_family_list = _tmp2_;
			_tmp3_ = _family_list;
			g_object_get ((StringHashset*) _tmp3_, "size", &_tmp4_, NULL);
			_tmp5_ = _tmp4_;
			_family_size = _tmp5_;
			_family_index = -1;
			while (TRUE) {
				gchar* family = NULL;
				FontManagerReject* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* sql = NULL;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				FontManagerDatabase* _tmp11_;
				const gchar* _tmp12_;
				_family_index = _family_index + 1;
				if (!(((guint) _family_index) < _family_size)) {
					break;
				}
				_tmp6_ = _family_list;
				_tmp7_ = string_hashset_get ((StringHashset*) _tmp6_, (guint) _family_index);
				_tmp8_ = g_strdup (_tmp7_);
				family = _tmp8_;
				_tmp9_ = family;
				_tmp10_ = g_strdup_printf ("SELECT DISTINCT filepath FROM Fonts WHERE family = '%s'", _tmp9_);
				sql = _tmp10_;
				_tmp11_ = db;
				_tmp12_ = sql;
				font_manager_database_execute_query (_tmp11_, _tmp12_, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_free0 (sql);
					_g_free0 (family);
					_g_object_unref0 (_family_list);
					_g_object_unref0 (db);
					goto __catch6_g_error;
				}
				{
					FontManagerDatabaseIterator* _stmt_it = NULL;
					FontManagerDatabase* _tmp13_;
					FontManagerDatabaseIterator* _tmp14_;
					_tmp13_ = db;
					_tmp14_ = font_manager_database_iterator (_tmp13_);
					_stmt_it = _tmp14_;
					while (TRUE) {
						FontManagerDatabaseIterator* _tmp15_;
						sqlite3_stmt* stmt = NULL;
						FontManagerDatabaseIterator* _tmp16_;
						sqlite3_stmt* _tmp17_;
						gchar* path = NULL;
						sqlite3_stmt* _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						const gchar* _tmp21_;
						GFile* _tmp22_;
						GFile* _tmp23_;
						gboolean _tmp24_;
						_tmp15_ = _stmt_it;
						if (!font_manager_database_iterator_next (_tmp15_)) {
							break;
						}
						_tmp16_ = _stmt_it;
						_tmp17_ = font_manager_database_iterator_get (_tmp16_);
						stmt = _tmp17_;
						_tmp18_ = stmt;
						_tmp19_ = (const gchar*) sqlite3_column_text (_tmp18_, 0);
						_tmp20_ = g_strdup (_tmp19_);
						path = _tmp20_;
						_tmp21_ = path;
						_tmp22_ = g_file_new_for_path (_tmp21_);
						_tmp23_ = _tmp22_;
						_tmp24_ = g_file_query_exists (_tmp23_, NULL);
						_g_object_unref0 (_tmp23_);
						if (_tmp24_) {
							StringHashset* _tmp25_;
							const gchar* _tmp26_;
							_tmp25_ = results;
							_tmp26_ = path;
							string_hashset_add (_tmp25_, _tmp26_);
						}
						_g_free0 (path);
					}
					_g_object_unref0 (_stmt_it);
				}
				_g_free0 (sql);
				_g_free0 (family);
			}
			_g_object_unref0 (_family_list);
		}
		_g_object_unref0 (db);
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = e;
		_tmp28_ = _tmp27_->message;
		g_warning ("FontConfig.vala:451: %s", _tmp28_);
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (results);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = results;
	return result;
}

static void
font_manager_reject_class_init (FontManagerRejectClass * klass,
                                gpointer klass_data)
{
	font_manager_reject_parent_class = g_type_class_peek_parent (klass);
}

static void
font_manager_reject_instance_init (FontManagerReject * self,
                                   gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_reject_get_type (void)
{
	static volatile gsize font_manager_reject_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_reject_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerRejectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_reject_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerReject), 0, (GInstanceInitFunc) font_manager_reject_instance_init, NULL };
		GType font_manager_reject_type_id;
		font_manager_reject_type_id = g_type_register_static (font_manager_selections_get_type (), "FontManagerReject", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_reject_type_id__volatile, font_manager_reject_type_id);
	}
	return font_manager_reject_type_id__volatile;
}

static inline gpointer
font_manager_sources_get_instance_private (FontManagerSources* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerSources_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static void
__lambda30_ (FontManagerSources* self,
             GFile* f,
             GFile* of,
             GFileMonitorEvent ev)
{
	g_return_if_fail (f != NULL);
	font_manager_sources_update (self);
}

static void
___lambda30__font_manager_sources_file_monitors_changed (FontManagerSourcesFileMonitors* _sender,
                                                         GFile* file,
                                                         GFile* other_file,
                                                         GFileMonitorEvent event_type,
                                                         gpointer self)
{
	__lambda30_ ((FontManagerSources*) self, file, other_file, event_type);
}

FontManagerSources*
font_manager_sources_construct (GType object_type)
{
	FontManagerSources * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	FontManagerDirectories* _tmp2_;
	FontManagerDirectories* _tmp3_;
	FontManagerSourcesFileMonitors* _tmp4_;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GHashTable* _tmp7_;
	FontManagerSourcesFileMonitors* _tmp8_;
	self = (FontManagerSources*) font_manager_directories_construct (object_type);
	_tmp0_ = get_package_config_directory ();
	_tmp1_ = _tmp0_;
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
	_g_free0 (_tmp1_);
	g_object_set ((FontManagerSelections*) self, "target-element", "source", NULL);
	g_object_set ((FontManagerSelections*) self, "target-file", "Sources.xml", NULL);
	_tmp2_ = font_manager_directories_new ();
	_tmp3_ = _tmp2_;
	font_manager_sources_set_active (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = font_manager_sources_file_monitors_new ();
	_g_object_unref0 (self->priv->monitors);
	self->priv->monitors = _tmp4_;
	_tmp5_ = g_str_hash;
	_tmp6_ = g_str_equal;
	_tmp7_ = g_hash_table_new_full (_tmp5_, _tmp6_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->sources);
	self->priv->sources = _tmp7_;
	_tmp8_ = self->priv->monitors;
	g_signal_connect_object (_tmp8_, "changed", (GCallback) ___lambda30__font_manager_sources_file_monitors_changed, self, 0);
	return self;
}

FontManagerSources*
font_manager_sources_new (void)
{
	return font_manager_sources_construct (FONT_MANAGER_TYPE_SOURCES);
}

GList*
font_manager_sources_list_objects (FontManagerSources* self)
{
	GList* result = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->sources;
	_tmp1_ = g_hash_table_get_values (_tmp0_);
	result = _tmp1_;
	return result;
}

void
font_manager_sources_update (FontManagerSources* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->sources;
	_tmp1_ = g_hash_table_get_values (_tmp0_);
	{
		GList* source_collection = NULL;
		GList* source_it = NULL;
		source_collection = _tmp1_;
		for (source_it = source_collection; source_it != NULL; source_it = source_it->next) {
			FontManagerSource* _tmp2_;
			FontManagerSource* source = NULL;
			_tmp2_ = _g_object_ref0 ((FontManagerSource*) source_it->data);
			source = _tmp2_;
			{
				FontManagerSource* _tmp3_;
				FontManagerSource* _tmp4_;
				FontManagerDirectories* _tmp5_;
				FontManagerSource* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				_tmp3_ = source;
				font_manager_source_update (_tmp3_);
				_tmp4_ = source;
				_tmp5_ = self->priv->_active;
				_tmp6_ = source;
				g_object_get (_tmp6_, "path", &_tmp7_, NULL);
				_tmp8_ = _tmp7_;
				_tmp9_ = _tmp8_;
				g_object_set (_tmp4_, "active", string_hashset_contains ((StringHashset*) _tmp5_, _tmp9_), NULL);
				_g_free0 (_tmp9_);
				_g_object_unref0 (source);
			}
		}
		(source_collection == NULL) ? NULL : (source_collection = (g_list_free (source_collection), NULL));
	}
	return;
}

gboolean
font_manager_sources_add_from_path (FontManagerSources* self,
                                    const gchar* dirpath)
{
	gboolean result = FALSE;
	GFile* _tmp0_;
	GFile* _tmp1_;
	FontManagerSource* _tmp2_;
	FontManagerSource* _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (dirpath != NULL, FALSE);
	_tmp0_ = g_file_new_for_path (dirpath);
	_tmp1_ = _tmp0_;
	_tmp2_ = font_manager_source_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = font_manager_sources_add (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		FontManagerSources* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->source);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
__lambda31_ (Block3Data* _data3_)
{
	FontManagerSources* self;
	self = _data3_->self;
	font_manager_sources_source_activated (self, _data3_->source);
}

static void
___lambda31__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda31_ (self);
}

gboolean
font_manager_sources_add (FontManagerSources* self,
                          FontManagerSource* source)
{
	gboolean result = FALSE;
	Block3Data* _data3_;
	FontManagerSource* _tmp0_;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gconstpointer _tmp5_;
	gboolean _tmp6_;
	GHashTable* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	FontManagerSource* _tmp10_;
	GHashTable* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gconstpointer _tmp15_;
	gboolean _tmp16_;
	FontManagerDirectories* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	FontManagerSourcesFileMonitors* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gboolean _tmp29_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (source);
	_g_object_unref0 (_data3_->source);
	_data3_->source = _tmp0_;
	_tmp1_ = self->priv->sources;
	g_object_get (_data3_->source, "path", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp5_ = g_hash_table_lookup (_tmp1_, _tmp4_);
	_tmp6_ = ((FontManagerSource*) _tmp5_) != NULL;
	_g_free0 (_tmp4_);
	if (_tmp6_) {
		result = TRUE;
		block3_data_unref (_data3_);
		_data3_ = NULL;
		return result;
	}
	_tmp7_ = self->priv->sources;
	g_object_get (_data3_->source, "path", &_tmp8_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = _g_object_ref0 (_data3_->source);
	g_hash_table_insert (_tmp7_, _tmp9_, _tmp10_);
	_tmp11_ = self->priv->sources;
	g_object_get (_data3_->source, "path", &_tmp12_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = _tmp13_;
	_tmp15_ = g_hash_table_lookup (_tmp11_, _tmp14_);
	_tmp16_ = ((FontManagerSource*) _tmp15_) == NULL;
	_g_free0 (_tmp14_);
	if (_tmp16_) {
		result = FALSE;
		block3_data_unref (_data3_);
		_data3_ = NULL;
		return result;
	}
	_tmp17_ = self->priv->_active;
	g_object_get (_data3_->source, "path", &_tmp18_, NULL);
	_tmp19_ = _tmp18_;
	_tmp20_ = _tmp19_;
	_tmp21_ = string_hashset_contains ((StringHashset*) _tmp17_, _tmp20_);
	_g_free0 (_tmp20_);
	if (_tmp21_) {
		g_object_set (_data3_->source, "active", TRUE, NULL);
	}
	g_signal_connect_data ((GObject*) _data3_->source, "notify::active", (GCallback) ___lambda31__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp22_ = self->priv->monitors;
	g_object_get (_data3_->source, "path", &_tmp23_, NULL);
	_tmp24_ = _tmp23_;
	_tmp25_ = _tmp24_;
	font_manager_sources_file_monitors_add (_tmp22_, _tmp25_);
	_g_free0 (_tmp25_);
	g_object_get (_data3_->source, "path", &_tmp26_, NULL);
	_tmp27_ = _tmp26_;
	_tmp28_ = _tmp27_;
	_tmp29_ = string_hashset_add ((StringHashset*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories), _tmp28_);
	_g_free0 (_tmp28_);
	result = _tmp29_;
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return result;
}

static void
font_manager_sources_purge_entries_data_free (gpointer _data)
{
	FontManagerSourcesPurgeEntriesData* _data_;
	_data_ = _data;
	_g_free0 (_data_->path);
	_g_object_unref0 (_data_->self);
	g_slice_free (FontManagerSourcesPurgeEntriesData, _data_);
}

static void
font_manager_sources_purge_entries_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	FontManagerSourcesPurgeEntriesData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

void
font_manager_sources_purge_entries (FontManagerSources* self,
                                    const gchar* path,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FontManagerSourcesPurgeEntriesData* _data_;
	FontManagerSources* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (FontManagerSourcesPurgeEntriesData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, font_manager_sources_purge_entries_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, font_manager_sources_purge_entries_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (path);
	_g_free0 (_data_->path);
	_data_->path = _tmp1_;
	font_manager_sources_purge_entries_co (_data_);
}

void
font_manager_sources_purge_entries_finish (FontManagerSources* self,
                                           GAsyncResult* _res_)
{
	FontManagerSourcesPurgeEntriesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
_font_manager_sources_purge_entries_co_gsource_func (gpointer self)
{
	gboolean result;
	result = font_manager_sources_purge_entries_co (self);
	return result;
}

static gboolean
font_manager_sources_purge_entries_co (FontManagerSourcesPurgeEntriesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_new0 (FontManagerDatabaseType, 3);
	_data_->_tmp0_[0] = FONT_MANAGER_DATABASE_TYPE_FONT;
	_data_->_tmp0_[1] = FONT_MANAGER_DATABASE_TYPE_METADATA;
	_data_->_tmp0_[2] = FONT_MANAGER_DATABASE_TYPE_ORTHOGRAPHY;
	_data_->types = _data_->_tmp0_;
	_data_->types_length1 = 3;
	_data_->_types_size_ = _data_->types_length1;
	{
		_data_->_tmp1_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_BASE, &_data_->_inner_error0_);
		_data_->db = _data_->_tmp1_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
				goto __catch7_font_manager_database_error;
			}
			_data_->types = (g_free (_data_->types), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp2_ = _data_->types;
		_data_->_tmp2__length1 = _data_->types_length1;
		{
			_data_->type_collection_length1 = 0;
			_data_->_type_collection_size_ = 0;
			_data_->type_collection = _data_->_tmp2_;
			_data_->type_collection_length1 = _data_->_tmp2__length1;
			for (_data_->type_it = 0; _data_->type_it < _data_->type_collection_length1; _data_->type_it = _data_->type_it + 1) {
				_data_->type = _data_->type_collection[_data_->type_it];
				{
					_data_->_tmp3_ = _data_->type;
					_data_->_tmp4_ = font_manager_database_get_type_name (_data_->_tmp3_);
					_data_->_tmp5_ = g_strdup (_data_->_tmp4_);
					_data_->name = _data_->_tmp5_;
					_data_->_tmp6_ = _data_->db;
					_data_->_tmp7_ = _data_->name;
					_data_->_tmp8_ = g_strdup_printf ("DELETE FROM %s WHERE filepath LIKE \"%%s%\"", _data_->_tmp7_, _data_->path);
					_data_->_tmp9_ = _data_->_tmp8_;
					font_manager_database_execute_query (_data_->_tmp6_, _data_->_tmp9_, &_data_->_inner_error0_);
					_g_free0 (_data_->_tmp9_);
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						_g_free0 (_data_->name);
						_g_object_unref0 (_data_->db);
						if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
							goto __catch7_font_manager_database_error;
						}
						_g_free0 (_data_->name);
						_g_object_unref0 (_data_->db);
						_data_->types = (g_free (_data_->types), NULL);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
						g_clear_error (&_data_->_inner_error0_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
					_data_->_tmp10_ = _data_->db;
					_data_->_tmp11_ = _data_->_tmp10_->stmt;
					sqlite3_step (_data_->_tmp11_);
					_g_free0 (_data_->name);
				}
			}
		}
		_g_object_unref0 (_data_->db);
		_data_->db = NULL;
		_data_->_tmp12_ = _data_->types;
		_data_->_tmp12__length1 = _data_->types_length1;
		{
			_data_->_vala1_type_collection_length1 = 0;
			_data_->__vala1_type_collection_size_ = 0;
			_data_->_vala1_type_collection = _data_->_tmp12_;
			_data_->_vala1_type_collection_length1 = _data_->_tmp12__length1;
			for (_data_->_vala1_type_it = 0; _data_->_vala1_type_it < _data_->_vala1_type_collection_length1; _data_->_vala1_type_it = _data_->_vala1_type_it + 1) {
				_data_->_vala1_type = _data_->_vala1_type_collection[_data_->_vala1_type_it];
				{
					_data_->_tmp14_ = _data_->_vala1_type;
					_data_->_tmp15_ = font_manager_get_database (_data_->_tmp14_, &_data_->_inner_error0_);
					_data_->_tmp13_ = _data_->_tmp15_;
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						_g_object_unref0 (_data_->db);
						if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
							goto __catch7_font_manager_database_error;
						}
						_g_object_unref0 (_data_->db);
						_data_->types = (g_free (_data_->types), NULL);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
						g_clear_error (&_data_->_inner_error0_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
					_data_->_tmp16_ = _data_->_tmp13_;
					_data_->_tmp13_ = NULL;
					_g_object_unref0 (_data_->db);
					_data_->db = _data_->_tmp16_;
					_data_->_tmp17_ = _data_->db;
					font_manager_database_execute_query (_data_->_tmp17_, "VACUUM", &_data_->_inner_error0_);
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						_g_object_unref0 (_data_->_tmp13_);
						_g_object_unref0 (_data_->db);
						if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
							goto __catch7_font_manager_database_error;
						}
						_g_object_unref0 (_data_->_tmp13_);
						_g_object_unref0 (_data_->db);
						_data_->types = (g_free (_data_->types), NULL);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
						g_clear_error (&_data_->_inner_error0_);
						g_object_unref (_data_->_async_result);
						return FALSE;
					}
					_data_->_tmp18_ = _data_->db;
					_data_->_tmp19_ = _data_->_tmp18_->stmt;
					sqlite3_step (_data_->_tmp19_);
					g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _font_manager_sources_purge_entries_co_gsource_func, _data_, NULL);
					_data_->_state_ = 1;
					return FALSE;
					_state_1:
					;
					_g_object_unref0 (_data_->_tmp13_);
				}
			}
		}
		_g_object_unref0 (_data_->db);
	}
	goto __finally7;
	__catch7_font_manager_database_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp20_ = _data_->e;
		if (_data_->_tmp20_->code != 1) {
			_data_->_tmp21_ = _data_->e;
			_data_->_tmp22_ = _data_->_tmp21_->message;
			g_warning ("FontConfig.vala:538: %s", _data_->_tmp22_);
		}
		_g_error_free0 (_data_->e);
	}
	__finally7:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_data_->types = (g_free (_data_->types), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->types = (g_free (_data_->types), NULL);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
	_data_->types = (g_free (_data_->types), NULL);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
__lambda32_ (FontManagerSources* self,
             GObject* obj,
             GAsyncResult* res)
{
	g_return_if_fail (res != NULL);
	font_manager_sources_purge_entries_finish (self, res);
}

static void
___lambda32__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda32_ ((FontManagerSources*) self, source_object, res);
	g_object_unref (self);
}

gboolean
font_manager_sources_remove (FontManagerSources* self,
                             FontManagerSource* source)
{
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gconstpointer _tmp8_;
	gboolean _tmp9_;
	FontManagerDirectories* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
	FontManagerSourcesFileMonitors* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_tmp0_ = self->priv->sources;
	g_object_get (source, "path", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	g_hash_table_remove (_tmp0_, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = self->priv->sources;
	g_object_get (source, "path", &_tmp5_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp8_ = g_hash_table_lookup (_tmp4_, _tmp7_);
	_tmp9_ = ((FontManagerSource*) _tmp8_) != NULL;
	_g_free0 (_tmp7_);
	if (_tmp9_) {
		result = FALSE;
		return result;
	}
	_tmp10_ = self->priv->_active;
	g_object_get (source, "path", &_tmp11_, NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_;
	_tmp14_ = string_hashset_contains ((StringHashset*) _tmp10_, _tmp13_);
	_g_free0 (_tmp13_);
	if (_tmp14_) {
		FontManagerDirectories* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		FontManagerDirectories* _tmp19_;
		_tmp15_ = self->priv->_active;
		g_object_get (source, "path", &_tmp16_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_;
		string_hashset_remove ((StringHashset*) _tmp15_, _tmp18_);
		_g_free0 (_tmp18_);
		_tmp19_ = self->priv->_active;
		font_manager_selections_save ((FontManagerSelections*) _tmp19_);
	}
	_tmp20_ = self->priv->monitors;
	g_object_get (source, "path", &_tmp21_, NULL);
	_tmp22_ = _tmp21_;
	_tmp23_ = _tmp22_;
	font_manager_sources_file_monitors_remove (_tmp20_, _tmp23_);
	_g_free0 (_tmp23_);
	g_object_get (source, "path", &_tmp24_, NULL);
	_tmp25_ = _tmp24_;
	_tmp26_ = _tmp25_;
	string_hashset_remove ((StringHashset*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories), _tmp26_);
	_g_free0 (_tmp26_);
	g_object_get (source, "path", &_tmp27_, NULL);
	_tmp28_ = _tmp27_;
	_tmp29_ = _tmp28_;
	font_manager_sources_purge_entries (self, _tmp29_, ___lambda32__gasync_ready_callback, g_object_ref (self));
	_g_free0 (_tmp29_);
	result = TRUE;
	return result;
}

static void
font_manager_sources_source_activated (FontManagerSources* self,
                                       FontManagerSource* source)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	FontManagerDirectories* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_object_get (source, "active", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		FontManagerDirectories* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp2_ = self->priv->_active;
		g_object_get (source, "path", &_tmp3_, NULL);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_;
		string_hashset_add ((StringHashset*) _tmp2_, _tmp5_);
		_g_free0 (_tmp5_);
	} else {
		FontManagerDirectories* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gboolean _tmp10_;
		_tmp6_ = self->priv->_active;
		g_object_get (source, "path", &_tmp7_, NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp10_ = string_hashset_contains ((StringHashset*) _tmp6_, _tmp9_);
		_g_free0 (_tmp9_);
		if (_tmp10_) {
			FontManagerDirectories* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp11_ = self->priv->_active;
			g_object_get (source, "path", &_tmp12_, NULL);
			_tmp13_ = _tmp12_;
			_tmp14_ = _tmp13_;
			string_hashset_remove ((StringHashset*) _tmp11_, _tmp14_);
			_g_free0 (_tmp14_);
		}
	}
	_tmp15_ = self->priv->_active;
	font_manager_selections_save ((FontManagerSelections*) _tmp15_);
	return;
}

/**
         * {@inheritDoc}
         */
gboolean
font_manager_sources_load (FontManagerSources* self)
{
	gboolean result = FALSE;
	FontManagerDirectories* _tmp0_;
	GList* _tmp1_;
	FontManagerDirectories* _tmp4_;
	GList* _tmp5_;
	g_return_val_if_fail (self != NULL, FALSE);
	FONT_MANAGER_SELECTIONS_CLASS (font_manager_sources_parent_class)->load ((FontManagerSelections*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories));
	_tmp0_ = self->priv->_active;
	font_manager_selections_load ((FontManagerSelections*) _tmp0_);
	_tmp1_ = string_hashset_list ((StringHashset*) self);
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
		path_collection = _tmp1_;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			gchar* _tmp2_;
			gchar* path = NULL;
			_tmp2_ = g_strdup ((const gchar*) path_it->data);
			path = _tmp2_;
			{
				const gchar* _tmp3_;
				_tmp3_ = path;
				font_manager_sources_add_from_path (self, _tmp3_);
				_g_free0 (path);
			}
		}
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free__g_free0_ (path_collection), NULL));
	}
	_tmp4_ = self->priv->_active;
	_tmp5_ = string_hashset_list ((StringHashset*) _tmp4_);
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
		path_collection = _tmp5_;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			gchar* _tmp6_;
			gchar* path = NULL;
			_tmp6_ = g_strdup ((const gchar*) path_it->data);
			path = _tmp6_;
			{
				const gchar* _tmp7_;
				_tmp7_ = path;
				font_manager_sources_add_from_path (self, _tmp7_);
				_g_free0 (path);
			}
		}
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free__g_free0_ (path_collection), NULL));
	}
	result = TRUE;
	return result;
}

FontManagerDirectories*
font_manager_sources_get_active (FontManagerSources* self)
{
	FontManagerDirectories* result;
	FontManagerDirectories* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_active;
	result = _tmp0_;
	return result;
}

static void
font_manager_sources_set_active (FontManagerSources* self,
                                 FontManagerDirectories* value)
{
	g_return_if_fail (self != NULL);
	if (font_manager_sources_get_active (self) != value) {
		FontManagerDirectories* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_active);
		self->priv->_active = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, font_manager_sources_properties[FONT_MANAGER_SOURCES_ACTIVE_PROPERTY]);
	}
}

static inline gpointer
font_manager_sources_file_monitors_get_instance_private (FontManagerSourcesFileMonitors* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerSourcesFileMonitors_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
font_manager_sources_file_monitors_notify_on_mount_event (FontManagerSourcesFileMonitors* self,
                                                          GMount* mount)
{
	gchar* path = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GHashTable* _tmp8_;
	GList* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mount != NULL);
	_tmp0_ = g_mount_get_default_location (mount);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	path = _tmp3_;
	_tmp5_ = path;
	if (_tmp5_ == NULL) {
		_tmp4_ = TRUE;
	} else {
		guint _tmp6_;
		guint _tmp7_;
		_tmp6_ = font_manager_sources_file_monitors_get_size (self);
		_tmp7_ = _tmp6_;
		_tmp4_ = _tmp7_ < ((guint) 1);
	}
	if (_tmp4_) {
		_g_free0 (path);
		return;
	}
	_tmp8_ = self->priv->monitors;
	_tmp9_ = g_hash_table_get_keys (_tmp8_);
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
		s_collection = _tmp9_;
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
			const gchar* s = NULL;
			s = (const gchar*) s_it->data;
			{
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				_tmp10_ = s;
				_tmp11_ = path;
				if (string_contains (_tmp10_, _tmp11_)) {
					GFile* _tmp12_;
					GFile* _tmp13_;
					_tmp12_ = g_mount_get_root (mount);
					_tmp13_ = _tmp12_;
					g_signal_emit (self, font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL], 0, _tmp13_, NULL, G_FILE_MONITOR_EVENT_CHANGED);
					_g_object_unref0 (_tmp13_);
				}
			}
		}
		(s_collection == NULL) ? NULL : (s_collection = (g_list_free (s_collection), NULL));
	}
	_g_free0 (path);
	return;
}

static void
___lambda26_ (FontManagerSourcesFileMonitors* self,
              GFile* f,
              GFile* of,
              GFileMonitorEvent ev)
{
	g_return_if_fail (f != NULL);
	g_signal_emit (self, font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL], 0, f, of, ev);
}

static void
____lambda26__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
	___lambda26_ ((FontManagerSourcesFileMonitors*) self, file, other_file, event_type);
}

gboolean
font_manager_sources_file_monitors_add (FontManagerSourcesFileMonitors* self,
                                        const gchar* path)
{
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	GHashTable* _tmp16_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = self->priv->monitors;
	if (g_hash_table_contains (_tmp0_, path)) {
		result = TRUE;
		return result;
	}
	{
		GFile* file = NULL;
		GFile* _tmp1_;
		GFileMonitor* monitor = NULL;
		GFile* _tmp2_;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		GHashTable* _tmp5_;
		gchar* _tmp6_;
		GFileMonitor* _tmp7_;
		GFileMonitor* _tmp8_;
		GHashTable* _tmp9_;
		gconstpointer _tmp10_;
		GFileMonitor* _tmp11_;
		GFileMonitor* _tmp12_;
		_tmp1_ = g_file_new_for_path (path);
		file = _tmp1_;
		_tmp2_ = file;
		_tmp3_ = g_file_monitor (_tmp2_, G_FILE_MONITOR_WATCH_MOUNTS, NULL, &_inner_error0_);
		monitor = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			goto __catch8_g_error;
		}
		_tmp4_ = monitor;
		_vala_assert (_tmp4_ != NULL, "monitor != null");
		_tmp5_ = self->priv->monitors;
		_tmp6_ = g_strdup (path);
		_tmp7_ = monitor;
		_tmp8_ = _g_object_ref0 (_tmp7_);
		g_hash_table_insert (_tmp5_, _tmp6_, _tmp8_);
		_tmp9_ = self->priv->monitors;
		_tmp10_ = g_hash_table_lookup (_tmp9_, path);
		_vala_assert (((GFileMonitor*) _tmp10_) != NULL, "monitors.lookup(path) != null");
		_tmp11_ = monitor;
		g_signal_connect_object (_tmp11_, "changed", (GCallback) ____lambda26__g_file_monitor_changed, self, 0);
		_tmp12_ = monitor;
		g_file_monitor_set_rate_limit (_tmp12_, 3000);
		_g_object_unref0 (monitor);
		_g_object_unref0 (file);
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_warning ("FontConfig.vala:632: Failed to create FileMonitor for %s : %s", path, _tmp14_);
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally8:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp15_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp15_;
	}
	_tmp16_ = self->priv->monitors;
	if (!g_hash_table_contains (_tmp16_, path)) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

gboolean
font_manager_sources_file_monitors_remove (FontManagerSourcesFileMonitors* self,
                                           const gchar* path)
{
	gboolean result = FALSE;
	GFileMonitor* monitor = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GHashTable* _tmp5_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = self->priv->monitors;
	_tmp1_ = g_hash_table_lookup (_tmp0_, path);
	_tmp2_ = _g_object_ref0 ((GFileMonitor*) _tmp1_);
	monitor = _tmp2_;
	_tmp3_ = monitor;
	if (_tmp3_ != NULL) {
		GFileMonitor* _tmp4_;
		_tmp4_ = monitor;
		g_file_monitor_cancel (_tmp4_);
	}
	_tmp5_ = self->priv->monitors;
	result = g_hash_table_remove (_tmp5_, path);
	_g_object_unref0 (monitor);
	return result;
}

FontManagerSourcesFileMonitors*
font_manager_sources_file_monitors_construct (GType object_type)
{
	FontManagerSourcesFileMonitors * self = NULL;
	self = (FontManagerSourcesFileMonitors*) g_object_new (object_type, NULL);
	return self;
}

FontManagerSourcesFileMonitors*
font_manager_sources_file_monitors_new (void)
{
	return font_manager_sources_file_monitors_construct (FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS);
}

guint
font_manager_sources_file_monitors_get_size (FontManagerSourcesFileMonitors* self)
{
	guint result;
	GHashTable* _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->monitors;
	result = g_hash_table_size (_tmp0_);
	return result;
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_ENUM) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_enum (param_values + 3), data2);
}

static void
_font_manager_sources_file_monitors___lambda27_ (FontManagerSourcesFileMonitors* self,
                                                 GMount* m)
{
	g_return_if_fail (m != NULL);
	font_manager_sources_file_monitors_notify_on_mount_event (self, m);
}

static void
__font_manager_sources_file_monitors___lambda27__g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                               GMount* mount,
                                                                               gpointer self)
{
	_font_manager_sources_file_monitors___lambda27_ ((FontManagerSourcesFileMonitors*) self, mount);
}

static void
_font_manager_sources_file_monitors___lambda28_ (FontManagerSourcesFileMonitors* self,
                                                 GMount* m)
{
	g_return_if_fail (m != NULL);
	font_manager_sources_file_monitors_notify_on_mount_event (self, m);
}

static void
__font_manager_sources_file_monitors___lambda28__g_volume_monitor_mount_changed (GVolumeMonitor* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self)
{
	_font_manager_sources_file_monitors___lambda28_ ((FontManagerSourcesFileMonitors*) self, mount);
}

static void
_font_manager_sources_file_monitors___lambda29_ (FontManagerSourcesFileMonitors* self,
                                                 GMount* m)
{
	g_return_if_fail (m != NULL);
	font_manager_sources_file_monitors_notify_on_mount_event (self, m);
}

static void
__font_manager_sources_file_monitors___lambda29__g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self)
{
	_font_manager_sources_file_monitors___lambda29_ ((FontManagerSourcesFileMonitors*) self, mount);
}

static GObject *
font_manager_sources_file_monitors_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerSourcesFileMonitors * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GVolumeMonitor* _tmp3_;
	GVolumeMonitor* _tmp4_;
	GVolumeMonitor* _tmp5_;
	GVolumeMonitor* _tmp6_;
	parent_class = G_OBJECT_CLASS (font_manager_sources_file_monitors_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->monitors);
	self->priv->monitors = _tmp2_;
	_tmp3_ = g_volume_monitor_get ();
	_g_object_unref0 (self->priv->volume_monitor);
	self->priv->volume_monitor = _tmp3_;
	_tmp4_ = self->priv->volume_monitor;
	g_signal_connect_object (_tmp4_, "mount-added", (GCallback) __font_manager_sources_file_monitors___lambda27__g_volume_monitor_mount_added, self, 0);
	_tmp5_ = self->priv->volume_monitor;
	g_signal_connect_object (_tmp5_, "mount-changed", (GCallback) __font_manager_sources_file_monitors___lambda28__g_volume_monitor_mount_changed, self, 0);
	_tmp6_ = self->priv->volume_monitor;
	g_signal_connect_object (_tmp6_, "mount-removed", (GCallback) __font_manager_sources_file_monitors___lambda29__g_volume_monitor_mount_removed, self, 0);
	return obj;
}

static void
font_manager_sources_file_monitors_class_init (FontManagerSourcesFileMonitorsClass * klass,
                                               gpointer klass_data)
{
	font_manager_sources_file_monitors_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerSourcesFileMonitors_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_sources_file_monitors_get_property;
	G_OBJECT_CLASS (klass)->constructor = font_manager_sources_file_monitors_constructor;
	G_OBJECT_CLASS (klass)->finalize = font_manager_sources_file_monitors_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY, font_manager_sources_file_monitors_properties[FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY] = g_param_spec_uint ("size", "size", "size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_monitor_event_get_type ());
}

static void
font_manager_sources_file_monitors_instance_init (FontManagerSourcesFileMonitors * self,
                                                  gpointer klass)
{
	self->priv = font_manager_sources_file_monitors_get_instance_private (self);
}

static void
font_manager_sources_file_monitors_finalize (GObject * obj)
{
	FontManagerSourcesFileMonitors * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors);
	_g_object_unref0 (self->priv->volume_monitor);
	_g_hash_table_unref0 (self->priv->monitors);
	G_OBJECT_CLASS (font_manager_sources_file_monitors_parent_class)->finalize (obj);
}

GType
font_manager_sources_file_monitors_get_type (void)
{
	static volatile gsize font_manager_sources_file_monitors_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_sources_file_monitors_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerSourcesFileMonitorsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_sources_file_monitors_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerSourcesFileMonitors), 0, (GInstanceInitFunc) font_manager_sources_file_monitors_instance_init, NULL };
		GType font_manager_sources_file_monitors_type_id;
		font_manager_sources_file_monitors_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerSourcesFileMonitors", &g_define_type_info, 0);
		FontManagerSourcesFileMonitors_private_offset = g_type_add_instance_private (font_manager_sources_file_monitors_type_id, sizeof (FontManagerSourcesFileMonitorsPrivate));
		g_once_init_leave (&font_manager_sources_file_monitors_type_id__volatile, font_manager_sources_file_monitors_type_id);
	}
	return font_manager_sources_file_monitors_type_id__volatile;
}

static void
_vala_font_manager_sources_file_monitors_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	FontManagerSourcesFileMonitors * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors);
	switch (property_id) {
		case FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY:
		g_value_set_uint (value, font_manager_sources_file_monitors_get_size (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
font_manager_sources_class_init (FontManagerSourcesClass * klass,
                                 gpointer klass_data)
{
	font_manager_sources_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FontManagerSources_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_sources_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_sources_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_manager_sources_finalize;
	/**
	         * Sources:active:
	         *
	         * #Directories instance, required in order to update FontConfig
	         * directory configuration whenever a #Source is activated/deactivated.
	         */
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_SOURCES_ACTIVE_PROPERTY, font_manager_sources_properties[FONT_MANAGER_SOURCES_ACTIVE_PROPERTY] = g_param_spec_object ("active", "active", "active", FONT_MANAGER_TYPE_DIRECTORIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
font_manager_sources_instance_init (FontManagerSources * self,
                                    gpointer klass)
{
	self->priv = font_manager_sources_get_instance_private (self);
}

static void
font_manager_sources_finalize (GObject * obj)
{
	FontManagerSources * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_SOURCES, FontManagerSources);
	_g_object_unref0 (self->priv->_active);
	_g_object_unref0 (self->priv->monitors);
	_g_hash_table_unref0 (self->priv->sources);
	G_OBJECT_CLASS (font_manager_sources_parent_class)->finalize (obj);
}

/**
     * Sources - Represents an application specific configuration file
     *
     * <source> elements contain the full path to a directory containing
     * font files which should be available for preview within the application
     * and easily enabled for others.
     *
     * @seealso     load_user_font_sources ()
     */
GType
font_manager_sources_get_type (void)
{
	static volatile gsize font_manager_sources_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_sources_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerSourcesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_sources_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerSources), 0, (GInstanceInitFunc) font_manager_sources_instance_init, NULL };
		GType font_manager_sources_type_id;
		font_manager_sources_type_id = g_type_register_static (FONT_MANAGER_TYPE_DIRECTORIES, "FontManagerSources", &g_define_type_info, 0);
		FontManagerSources_private_offset = g_type_add_instance_private (font_manager_sources_type_id, sizeof (FontManagerSourcesPrivate));
		g_once_init_leave (&font_manager_sources_type_id__volatile, font_manager_sources_type_id);
	}
	return font_manager_sources_type_id__volatile;
}

static void
_vala_font_manager_sources_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	FontManagerSources * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_SOURCES, FontManagerSources);
	switch (property_id) {
		case FONT_MANAGER_SOURCES_ACTIVE_PROPERTY:
		g_value_set_object (value, font_manager_sources_get_active (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_font_manager_sources_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	FontManagerSources * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_SOURCES, FontManagerSources);
	switch (property_id) {
		case FONT_MANAGER_SOURCES_ACTIVE_PROPERTY:
		font_manager_sources_set_active (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

